<?php
// Nous allons faire notre propre gestion des erreurs
error_reporting(0);

// Fonction spciale de gestion des erreurs
function userErrorHandler($errno, $errmsg, $filename, $linenum, $vars) {
    // Date et heure de l'erreur
	$dt = date('Y-m-d H:i:s (T)');

	// Dfinit un tableau associatif avec les chanes d'erreur
	// En fait, les seuls niveaux qui nous interessent
	// sont E_WARNING, E_NOTICE, E_USER_ERROR,
	// E_USER_WARNING et E_USER_NOTICE
	$errortype = array (
		E_ERROR           => 'Erreur',
		E_WARNING         => 'Alerte',
		E_PARSE           => 'Erreur d\'analyse',
		E_NOTICE          => 'Note',
		E_CORE_ERROR      => 'Core Error',
		E_CORE_WARNING    => 'Core Warning',
		E_COMPILE_ERROR   => 'Compile Error',
		E_COMPILE_WARNING => 'Compile Warning',
		E_USER_ERROR      => 'Erreur spcifique',
		E_USER_WARNING    => 'Alerte spcifique',
		E_USER_NOTICE     => 'Note spcifique',
		E_STRICT          => 'Runtime Notice'
		);
	// Les niveaux qui seront enregistrs
	$user_errors = array(E_USER_ERROR, E_USER_WARNING, E_USER_NOTICE);

	$err = "<errorentry>\n";
	$err .= "\t<datetime>" . $dt . "</datetime>\n";
	$err .= "\t<errornum>" . $errno . "</errornum>\n";
	$err .= "\t<errortype>" . $errortype[$errno] . "</errortype>\n";
	$err .= "\t<errormsg>" . $errmsg . "</errormsg>\n";
	$err .= "\t<scriptname>" . $filename . "</scriptname>\n";
	$err .= "\t<scriptlinenum>" . $linenum . "</scriptlinenum>\n";

	if (in_array($errno, $user_errors)) {
		$err .= "\t<vartrace>".wddx_serialize_value($vars,"Variables")."</vartrace>\n";
	}
	$err .= "</errorentry>\n\n";

	// sauvegarde de l'erreur, et mail si c'est critique

	error_log($err, 3, rtrim($_SERVER['DOCUMENT_ROOT'], '/') . '/error.log');
	if (($errno == E_USER_ERROR) || ($errno == E_COMPILE_ERROR)) {
		send_mail('Critical User Error', $err);
	}       
}

$old_error_handler = set_error_handler('userErrorHandler');
?>
